#! /usr/bin/perl
	
if ($ENV{"REQUEST_METHOD"} eq "POST") {
  read(STDIN, $datastring, $ENV{"CONTENT_LENGTH"});		
}
elsif (exists $ENV{"REQUEST_METHOD"}) {		# data from GET transaction (or HEAD or other)
  $datastring = $ENV{"QUERY_STRING"};
}
else {
  print "Offline execution detected\n";
  print "Please enter some data.\n";
  $datastring = <>;
  chomp $datastring;
  print "== data accepted == HTML output follows ==\n\n";
}

###decode######################################################
$datastring =~s/%0D%0A/\n/g;                    			#step to deal with line
																											#breaks in text areas
@nameValuePairs = split(/&/, $datastring);						#step 1
foreach $pair (@nameValuePairs) {
  ($name, $value) = split(/=/, $pair);								#step 2
  
  $name =~tr/+/ /;                                 		#step 3
  $name =~s/%([\da-fA-F]{2})/pack("C",hex($1))/eg; 		#step 3
  $value =~tr/+/ /;                                		#step 3
  $value =~s/%([\da-fA-F]{2})/pack("C",hex($1))/eg;		#step 3
  
  if(exists $formHash{$name}) {												#improved step 4,
    $formHash{$name} = $formHash{$name}.";".$value;		#now handles multiple
  }																										#select menus
  else {
    $formHash{$name} = $value;
  }   	
}
###done decoding###############################################

### deal with any incoming cookies ############################
# Note:  Unlike the version in the book, this version of the cookie routine
# features some decoding to deal with any incoming cookies which have 
# some characters given by the hex ASCII number
%cookieHash = ();
@nameValuePairs = split(/; /, $ENV{"HTTP_COOKIE"});
foreach $pair (@nameValuePairs) {
	($name, $value) = split(/=/, $pair);
  $name =~s/%([\da-fA-F]{2})/pack("C",hex($1))/eg; #step 3.
  $value =~s/%([\da-fA-F]{2})/pack("C",hex($1))/eg;#step 3.
  $cookieHash{$name} = $value;
}
### done building %cookieHash ##################################


%greetings = (
   "USA" => "Welcome",
   "UK" => "Welcome",
   "Canada" => "Welcome",
   "France" => "Bienvenue",
   "Germany" => "Wilkommen",
   "Spain" => "Bienvenidos",
   "KlingonEmpire" => "nuqneH",
   "Romulus" => "Aefvadh"
 );
 
### app logic ##################################################

if($formHash{"request"} eq "reset") {
	&preference_page;
}
elsif( exists $cookieHash{"language"} || ($formHash{"request"} eq "custom_page") ) {
	&custom_page;
}
else {
	&preference_page;
}
### end app logic ###############################################


#################################################################
sub preference_page { 
 print "Content-type: text/html\n\n";
 print <<TOP;
 <html><head><title>Hello!</title></head><body>
   Please customize this site according to your country.
   If your country is not listed, please check back later.
    <form action="$ENV{'SCRIPT_NAME'}" method="GET">
    <select name="language">
TOP
  foreach $key (sort keys %greetings) {
    print "<option value=\"$key\">$key</option>\n";
  }

  print <<BOTTOM;
     </select>
     Always show my flag? <input type="checkbox" name="flag" value="yes" /><br />
		 <input type="hidden" name="request" value="custom_page" />
		 <input type="submit" value="Set Language" />
    </form>
    (Your browser must accept cookies in oder to use this site.)
 </body></html>
BOTTOM
}

#################################################################
sub custom_page {
	my ($language, $flag);
	
	if(exists $formHash{"language"}) { # the preference form has been submitted 
												   					 # to set or reset the preferences
		$language=$formHash{"language"};
		if(exists $formHash{"flag"}) {
    		$flag="yes";
    	}    		
  	else { 
  		$flag="no"; 
  	}
  }
 	else { # use the preferences set in cookies on the browser
 		$language=$cookieHash{"language"};
 		$flag=$cookieHash{"flag"};
 	}
 	
  my $expires = &one_year_from_now;
  print "Set-cookie: language=$language; path=/; expires=$expires\n";
  print "Set-cookie: flag=$flag; path=/; expires=$expires\n";
 
	my $greeting = $greetings{$language};

 	print "Content-type: text/html\n\n";
 	print <<TOP;
 	<html><head><title>$greeting</title></head><body>
TOP

  if($flag eq "yes") {
    print "<img src=\"$language.gif\" />";
  }

 print <<BOTTOM;
   <h3>$greeting</h3>
   <a href="$ENV{'SCRIPT_NAME'}?request=reset">Change your site preferences</a>
 </body></html>
BOTTOM
}

#################################################################
sub one_year_from_now {
	
my @days = ("Sun","Mon","Tues","Wed","Thu","Fri","Sat");
my @months = ("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");

#gmtime returns like localtime but in GMT
my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=gmtime;

$year+=1900; #current year

#augment week day by 1 to reflect the next year 
if($wday<6){
	$wday++;
}
else {
	$wday=0;
}

#if it's a leap year, augment week day by an extra 1 for any month after Feb
#day of month, mday, stays the same unless its leap year in which case Feb 29 becomes 28


if(($year % 4) == 0) { #leap year
	if($mon>1) {
		if($wday < 6){
			$wday++;
		}
		else {
			$wday=0;
		}
	}
	if(($mon == 1)&&($mday == 29)) {
		$mday=28;
	}
}


$year++;  #add 1 to the year

return "$days[$wday], $mday-$months[$mon]-$year $hour:$min:$sec GMT";
}

